﻿using System;
using System.Collections.Generic;
using System.Threading;
using System.Windows.Threading;
using SignalsMVVM.Interfaces;

namespace SignalsMVVM.Models
{
    public class LogController : IProcedureLogger
    {
        private Action<bool> IsThreadAlive { get; set; }
        private Dispatcher MainDispatcher { get; set; }
        private IList<BaseSignal> InputList { get; set; }
        private IList<BaseSignal> OutputList { get; set; }

        public LogController(Dispatcher dispatcher, IList<BaseSignal> inputList, IList<BaseSignal> outputList, Action<bool> isThreadAlive)
        {
            MainDispatcher = dispatcher;
            InputList = inputList;
            OutputList = outputList;
            IsThreadAlive = isThreadAlive;
        }

        public void ExecuteThread()
        {
            IsThreadAlive(true);
            foreach (BaseSignal signal in InputList)
            {
                MainDispatcher.Invoke(() => OutputList.Add(signal));
                Thread.Sleep(signal.Delay);
            }
            IsThreadAlive(false);
        }
    }
}
